package com.supercilex.robotscouter.common

// Common
const val FIRESTORE_ID = "id"
const val FIRESTORE_NAME = "name"
const val FIRESTORE_VALUE = "value"
const val FIRESTORE_TIMESTAMP = "timestamp"
const val FIRESTORE_OWNERS = "owners"

// User
const val FIRESTORE_USERS = "users"
const val FIRESTORE_LAST_LOGIN = "lastLogin"

// Team
const val FIRESTORE_TEAMS = "teams"
const val FIRESTORE_DUPLICATE_TEAMS = "duplicate-teams"
const val FIRESTORE_NUMBER = "number"
const val FIRESTORE_MEDIA = "media"
const val FIRESTORE_WEBSITE = "website"

// Shared
const val FIRESTORE_REF = "ref"
const val FIRESTORE_PREV_UID = "prevUid"
const val FIRESTORE_TOKEN = "token"
const val FIRESTORE_ACTIVE_TOKENS = "activeTokens"

// Scout
const val FIRESTORE_SCOUTS = "scouts"
const val FIRESTORE_METRICS = "metrics"
const val FIRESTORE_POSITION = "position"
const val FIRESTORE_TYPE = "type"
const val FIRESTORE_UNIT = "unit"
const val FIRESTORE_SELECTED_VALUE_ID = "selectedValueId"

// Templates
const val FIRESTORE_TEMPLATES = "templates"
const val FIRESTORE_DEFAULT_TEMPLATES = "default-templates"
const val FIRESTORE_TEMPLATE_ID = "templateId"

// Prefs
const val FIRESTORE_PREFS = "prefs"
const val FIRESTORE_PREF_DEFAULT_TEMPLATE_ID = "defaultTemplateId"
const val FIRESTORE_PREF_NIGHT_MODE = "nightMode"
const val FIRESTORE_PREF_LOCK_TEMPLATES = "lockTemplates"
const val FIRESTORE_PREF_UPLOAD_MEDIA_TO_TBA = "uploadMediaToTba"
const val FIRESTORE_PREF_HAS_SHOWN_ADD_TEAM_TUTORIAL = "hasShownAddTeamTutorial"
const val FIRESTORE_PREF_HAS_SHOWN_SIGN_IN_TUTORIAL = "hasShownSignInTutorial"
const val FIRESTORE_PREF_SHOULD_SHOW_RATING_DIALOG = "shouldShowRatingDialog"

// Queue
const val FIRESTORE_DELETION_QUEUE = "deletion-queue"
const val FIRESTORE_CONTENT_ID = "contentId"
const val FIRESTORE_SHARE_TYPE = "shareType"
const val FIRESTORE_BASE_TIMESTAMP = "baseTimestamp"

enum class DeletionType(val id: Int) {
    TEAM(0),
    SCOUT(1),
    TEMPLATE(2),
    SHARE_TOKEN(3);

    companion object {
        fun valueOf(id: Number) = requireNotNull(values().find { it.id == id.toInt() }) {
            "Unknown deletion type: $id"
        }
    }
}
